//"diag_img.sc","5img : diagnostyka indeksw dok. magazynowych",12004,0,1.0.0,SYSTEM
//"Diagnostyka",12001,14,16
////////////////////////////
// 5img : diagnostyka indeksw dok. magazynowych
// diag_img.sc
////////////////////////////
// Napisa: Sebastian Nowak
// data:    2000.02.15

string NAZWA_PLIKU = "DIAG_IMG.TXT"

#include "Diagnostyka baz indeksowych - include"
UsunRekord_0("img")

sDialogTitle += "indeksw dokumentw magazynowych"

StageAddDesc("Raport porwnuje zawarto bazy indeksowej IMG z zawartoci bazy MG")
StageAddDesc("i na tej podstawie dodaje lub usuwa rekordy w bazie indeksowej")
StageAddStage("Porwnanie z zawartoci bazy MG")
StageAddStage("Sprawdzenie wartoci w rekordach")
ChooseStages(400)

// ***************************

int sub ShouldMirrorRec( BaseAll b )
	ShouldMirrorRec = 1
	if b.GetField("typi") != 201 then ShouldMirrorRec=0
	if b.GetField("subtypi")==0 || b.GetField("subtypi")==2 then ShouldMirrorRec=0
endsub

int sub IsMirrorOK(int b_idx, BaseAll b_main)
	IsMirrorOK=0

	if GetField(b_idx,"id") != b_main.GetField("id") then exit
	if GetField(b_idx,"subtypi") != b_main.GetField("subtypi") then exit
	if GetField(b_idx,"typi") != b_main.GetField("typi") then exit
	if GetField(b_idx,"znaczniki") != b_main.GetField("znaczniki") then exit
	if GetField(b_idx,"rodzaj") != b_main.GetField("rodzaj") then exit
	if GetField(b_idx,"katalog") != b_main.GetField("katalog") then exit
	if GetField(b_idx,"osoba") != b_main.GetField("osoba") then exit
	if GetField(b_idx,"kod") != b_main.GetField("kod") then exit
	if GetField(b_idx,"seria") != b_main.GetField("seria") then exit
	if GetField(b_idx,"serianr") != b_main.GetField("serianr") then exit
	if GetField(b_idx,"okres") != b_main.GetField("okres") then exit
	if GetField(b_idx,"data") != b_main.GetField("data") then exit
	if Mid(GetField(b_idx,"opis"),1,39) != Mid(b_main.GetField("opis"),1,39) then exit
	if GetField(b_idx,"khid") != b_main.GetField("khid") then exit
	if GetField(b_idx,"khkod") != b_main.GetField("khkod") then exit
	if GetField(b_idx,"oki") != b_main.GetField("oki") then exit
	if GetField(b_idx,"termin") != b_main.GetField("termin") then exit
	if Sign(GetField(b_idx,"netto") - b_main.GetField("netto")) then exit
	if GetField(b_idx,"typ_dk") != b_main.GetField("typ_dk") then exit
	if GetField(b_idx,"rejestrVati") != b_main.GetField("rejestrVati") then exit
	if Sign(GetField(b_idx,"wartoscWz") - b_main.GetField("wartoscWz")) then exit
	if GetField(b_idx,"magazyn") != b_main.GetField("magazyn") then exit
	if GetField(b_idx,"dzial") != b_main.GetField("dzial") then exit
	if Sign(GetField(b_idx,"przychod") - b_main.GetField("przychod")) then exit
	if Sign(GetField(b_idx,"rozchod") - b_main.GetField("rozchod")) then exit
	if Sign(GetField(b_idx,"wartk") - b_main.GetField("wartk")) then exit

	IsMirrorOK=1
endsub
//   ***********************************

TextOut("Podsumowanie sprawdzania poprawnoci bazy indeksw dokumentw magazynowych\n\n")

if StageT(1) then
	SprawdzBaze("IMG")
	StageSummary(1)
endif

if StageT(2) then
	SprawdzDane("IMG")
	StageSummary(2)
endif

TextOut("\nZakoczono.")

ShowFileInfo()

close

buf = IIF( GetVError() == 0 , "" , "warnings" )