//"diag_imz.sc","5imz : diagnostyka indeksw pozycji magazynowych",12004,0,1.0.0,SYSTEM
//"Diagnostyka",12001,14,16
///////////////////
// 5imz : diagnostyka indeksw pozycji magazynowych
// diag_imz.sc
////////////////////////
// Napisa: Sebastian Nowak
// data:    2000.02.15

string NAZWA_PLIKU = "DIAG_IMZ.TXT"

#include "Diagnostyka baz indeksowych - include"
UsunRekord_0("imz")

sDialogTitle += "indeksw pozycji magazynowych"

StageAddDesc("Raport porwnuje zawarto bazy indeksowej IMZ z zawartoci bazy MZ")
StageAddDesc("i na tej podstawie dodaje lub usuwa rekordy w bazie indeksowej")
StageAddStage("Porwnanie z zawartoci bazy MZ")
StageAddStage("Sprawdzenie wartoci w rekordach")
ChooseStages(400)

// ***************************
int sub DiagWart(string pole, int prec, int b_idx)
float wart
float id

	wart = GetField(b_idx,pole)
	id = GetField(b_idx,"id")
	if sign(wart-round(wart,prec),6) then
		if TextOutAndAsk(3,(using "Warto pola '%s' posiada cyfry poza wymagan pozycj dokadnoci. Rekord id=%d",pole,id),(". Czy zaokrgli?")) then
			SetField(b_idx, pole, round(wart,prec))
			UpdateRec(b_idx,"")
		else
			TextOut(sNoRepair)
		endif
	endif
endsub
int sub ShouldMirrorRec( BaseAll b )
	ShouldMirrorRec = 1
	if b.GetField("typi") & 0x01 then ShouldMirrorRec=0
endsub

int sub IsMirrorOK(int b_idx, BaseAll b_main)
	DiagWart("ilosc",4,b_idx)
	DiagWart("przychod",2,b_idx)
	DiagWart("rozchod",2,b_idx)
	
	IsMirrorOK=0

	if GetField(b_idx,"id") != b_main.GetField("id") then exit
	if GetField(b_idx,"flag") != b_main.GetField("flag") then exit
	if GetField(b_idx,"subtypi") != b_main.GetField("subtypi") then exit
	if GetField(b_idx,"typi") != b_main.GetField("typi") then exit
	if GetField(b_idx,"super") != b_main.GetField("super") then exit
	if GetField(b_idx,"idkh") != b_main.GetField("idkh") then exit
	if GetField(b_idx,"idtw") != b_main.GetField("idtw") then exit
	if GetField(b_idx,"data") != b_main.GetField("data") then exit
	if Sign(GetField(b_idx,"ilosc") - b_main.GetField("ilosc"),5) then exit
	if GetField(b_idx,"magazyn") != b_main.GetField("magazyn") then exit
	if GetField(b_idx,"osoba") != b_main.GetField("osoba") then exit
	if Sign(GetField(b_idx,"przychod") - b_main.GetField("przychod")) then exit
	if Sign(GetField(b_idx,"rozchod") - b_main.GetField("rozchod")) then exit

	IsMirrorOK=1
endsub
//   ***********************************

TextOut("Podsumowanie sprawdzania poprawnoci bazy indeksw pozycji magazynowych\n\n")

if StageT(1) then
	SprawdzBaze("IMZ")
	StageSummary(1)
endif

if StageT(2) then
	SprawdzDane("IMZ")
	StageSummary(2)
endif

TextOut("\nZakoczono.")

ShowFileInfo()

close

buf = IIF( GetVError() == 0 , "" , "warnings" )