//"dokdat.sc","Bdne daty dokumentw -weryfikacja przed migracj",12010,0,1.0.2,SYSTEM  
//"Pomocnicze",12001,14,16
////////////////////////////
// Bdne daty dokumentw -weryfikacja przed migracj
// dokdat.sc
////////////////////////////

#define NAZWA_PLIKU "DOKDAT.TXT"

String sRaportDescription = "Raport sprawdza czy w bazie danych istniej dokumenty z datami pniejszymi ni "

#include "Diagnostyka - funkcje"

sRaportDescription += ( sVerifyMaxDate + "." )

Int		mainInfo , table, index
Long	counter
String 	tabKsZo(1), tabDs(1), tabDz(1), tabKzZw(1), tabDm(1)

Int Sub PrintInfo( String detailInfo )

	If mainInfo && counter && detailInfo != "" Then
		TextOut( "W bazie danych znaleziono dokumenty z datami pniejszymi ni " + sVerifyMaxDate + "\n\n" )
		mainInfo = 0
	EndIf
	If mainInfo && counter == 0 && detailInfo == "" Then
		TextOut( "W bazie danych nie znaleziono dokumentw z datami pniejszymi ni " + sVerifyMaxDate + "\n\n" )
		mainInfo = 0
	EndIf
	If counter Then
		TextOut( Using "%6l  -  %s\n" , counter , detailInfo )
	EndIf

EndSub

Int Sub CheckDocumentDate( String tableName, Int type, Int stock, String infoTab )

	Int		corruptDate
	String	documentDate

	counter = 0

	table = OpenBase( tableName )

	SetKey( table , "numer" )
	SetKeySeg( table , "typi" , type )
	err = GetRec( table , GE )
	While !err && GetField( table , "typi" ) == type
		corruptDate = 0
		documentDate = GetField( table,"data" )
		If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
		documentDate = GetField( table,"datasp" )
		If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
		if( !stock ) then
			documentDate = GetField( table,"plattermin" )
			If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
			documentDate = GetField( table,"datarej" )
			If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
			documentDate = GetField( table,"datawp" )
			If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
			documentDate = GetField( table,"data_obcy" )
			If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
		Else
			documentDate = GetField( table,"termin" )
			If AMSTRCMPI(documentDate, sVerifyMaxDate) > 0 Then corruptDate = 1
		EndIf
		If corruptDate Then 
			counter += 1
			if infoTab == "KSZO" then
				grow tabKsZo, 1
				tabKsZo(counter) = GetField(table, "kod")
			endif
			if infoTab == "DS" then
				grow tabDs, 1
				tabDs(counter) = GetField(table, "kod")
			endif
			if infoTab == "DZ" then
				grow tabDz, 1
				tabDz(counter) = GetField(table, "kod")
			endif
			if infoTab == "KZZW" then
				grow tabKzZw, 1
				tabKzZw(counter) = GetField(table, "kod")
			endif
			if infoTab == "DM" then
				grow tabDm, 1
				tabDm(counter) = GetField(table, "kod")
			endif
		Endif
		err = GetRec( table , NX )
	WEnd

	Close( table )

	IncreaseVError(counter)

EndSub

Int Sub ReadInfoTab(String infoTab, String infoText)
		If infoTab == "KSZO" then
			if tabKsZo(1) != "" then
				TextOut( Using "\n\n%s:" , infoText )
				for index = 1 to index >= Size(tabKsZo)
					if index != 1 && index<Size(tabKsZo) then
						Print ", "
					endif
					Print Using "%s", tabKsZo(index)
				next index
			Endif
		endif
		If infoTab == "DS" then
			if tabDs(1) != "" then
				TextOut( Using "\n\n%s:" , infoText )
				for index = 1 to index >= Size(tabDs)
					if index != 1 && index<Size(tabDs) then
						Print ", "
					endif
					Print Using "%s", tabDs(index)
				next index
			Endif
		endif
		If infoTab == "DZ" then
			if tabDz(1) != "" then
				TextOut( Using "\n\n%s:" , infoText )
				for index = 1 to index >= Size(tabDz)
					if index != 1 && index<Size(tabDz) then
						Print ", "
					endif
					Print Using "%s", tabDz(index)
				next index
			Endif
		endif
		If infoTab == "KZZW" then
			if tabKzZw(1) != "" then
				TextOut( Using "\n\n%s:" , infoText )
				for index = 1 to index >= Size(tabKzZw)
					if index != 1 && index<Size(tabKzZw) then
						Print ", "
					endif
					Print Using "%s", tabKzZw(index)
				next index
			Endif
		endif
		If infoTab == "DM" then
			if tabDm(1) != "" then
				TextOut( Using "\n\n%s:" , infoText )
				for index = 1 to index >= Size(tabDm)
					if index != 1 && index<Size(tabDm) then
						Print ", "
					endif
					Print Using "%s", tabDm(index)
				next index
			Endif
		endif
EndSub

mainInfo = 1

CheckDocumentDate("bd", 1, 0, "KSZO")
PrintInfo( "kontrakty sprzeday, zamwienia obce" )

CheckDocumentDate("dk", 0, 0, "DS")
PrintInfo( "dokumenty sprzeday" )

BASEDEF bdef
If !bdef.GetInfo( "mg" ) Then

	CheckDocumentDate("bd", 203, 0, "KZZW")
	PrintInfo( "kontrakty zakupu, zamwienia wasne" )

	CheckDocumentDate("dk", 202, 0, "DZ")
	PrintInfo( "dokumenty zakupu" )

	CheckDocumentDate("mg", 201, 1, "DM")
	PrintInfo( "dokumenty magazynowe" )

EndIf

ReadInfoTab("KSZO","Kontrakty sprzeday, zamwienia obce" )
ReadInfoTab("DS","Dokumenty sprzeday" )
ReadInfoTab("DZ","Dokumenty zakupu" )
ReadInfoTab("KZZW","Kontrakty zakupu, zamwienia wasne" )
ReadInfoTab("DM","Dokumenty magazynowe" )

TextOut("\n\nZakoczono")

ShowFileInfo()

Close

buf = IIF( GetVError() == 0 , "" , "corruptDate" )