//"inteFKRO.sci","Integracja RO do FK - include",12016,0,1.0.0,SYSTEM
//"Integracja z FK-a",12015,14,62
/////////////////////////////////////////
// inteFKRO.sci
// Integracja RO do FK - include

#define PANUL 3
#define BAS_RO  	0x105

int Sub IntegrRO(long idRO)

	IntegrRO = 0
	int err, nCzyWal, iStVat, iRejVat
	int iRok
	long idDK, lSuper
	string sRej,strRej
	int iPom, iPomStVat, iPos
	int index = 1
	String strOkres, strGTU
	string strTmp, symbolFK

	if basRO.GetRecById(idRO) then error "Brak takiego rekordu w bazie RO"

	iRok = dbd.firmainfo.GetRokByDate(basRO.GetField("DateFrom"))
	if RokFK(1).Zap == 1 then
		if RokFK(1).IdRok != iRok then
			UstawRok(iRok)
		endif
	else
		UstawRok(iRok)		
	endif

	dst=RokFK(1).Rok
	plkn=RokFK(1).PlanKont
	defdok=RokFK(1).DefDokument
	defrej = RokFK(1).DefRejestr

	#ifdef HM
		if basKH.GetRecById(basRO.GetField("magazyn")) then error "Brak magazynu w bazie."
	#endif

	//sigamy do definicji typu dokumentu
	basDK2.SetKey("numer")
	basDK2.SetKeySeg("typi", 101)	// KARTAdkTYP
	basDK2.SetKeySeg("kod",  basRO.GetField("DocumentType"))
	if basDK2.GetRec(EQ)  then error "Brak takiego rekordu w bazie DK"
	symbolFK = basDK2.GetField("khadres")
	//obslugujJak = basDK2.GetField("khkodpocz")

	IntegrRO = CzyIntegrBrakTypDK(symbolFK, basRO.GetField("Code"), idRO, basRO.GetField("DocumentType"))
	if IntegrRO then exit

	basKH.GetRecById(basRO.GetField("magazyn"))
	sOpisPom=Using "raport %s za dzie %s", basRO.GetField("Code"), basRO.GetField("DateFrom")

	dst.Clear()
	sOpisy=0
	dbd.CurrentDate = sDataWpr
	dataRejestrVATzbiorczy = basRO.GetField("DateFrom")

	dst.Value("DataDok") = basRO.GetField("DateFrom")
	dst.Value("DataOper") = basRO.GetField("DateTo")
	dst.Value("Datawpl") = Data()
	dst.Value("Datawpr") = sDataWpr
	dst.Value("Kwota") =  basRO.GetField("Gross")
	dst.Value("skrot") = symbolFK

	//////////////////////////////////////////////////////
	// numer dokumentu w FK
	dst.Value("nazwa") = basRO.GetField("Code")

	dst.Value("JPK_V7") = AggregatedJPK_V7()

	//////////// eksport dekretacji zbiorczej z dokumentw raportu okersowego ////////////////////
	dst.Value("tresc") = sOpisPom

	obl.Add(BAS_RO, idRO)

	int resDK, iVal
	long docID

#ifdef HM
	//zapisy magazynowe
	if iRownoKsiegMag then
		basDK.SetKey("idRO")
		basDK.SetKeySeg("idRO", idRO)
		resDK = basDK.GetRec(GE)
		While !resDK && basDK.GetKeySeg("idRO") == idRO
			docID = basDK.GetField("id")
		
			basMG.SetKey("idhandl")
			basMG.SetKeySeg("idhandl", docID)
			err = basMG.GetRec(GE)
			while !err && basMG.GetKeySeg("idhandl") == docID
				if !IntegrZatwWart(basMZ, basPW, basMG.GetField("id"), basMG.GetField("kod"), basDK.GetField("kod")) then
					//trzeba ustawi przy obliczeniach, ze jest to zapis rwnolegly, bo potem nie jestesmy w stanie tego rozrni
					obl.ZapisRownolegly = 1
					obl.Add(BAS_MG, basMG.GetField("id"))
					obl.ZapisRownolegly = 0
					if iOznaczaj then
						iVal |= 0x01
						basMG.SetField( "exp_fki", iVal )
						basMG.Update()
					endif

				endif				

				err = basMG.GetRec(NX)
			wend

			resDK = basDK.GetRec(NX)
		Wend
	endif
	if iDekretyZbiorcze then
		obl.OptymalizujZapRo() // trzeba zrobic laczenie tylko magazynowych
	endif
	//end zapisy magazynowe
#endif

	ZapiszZAP(obl, 0, 0, 0, basRO.GetField("DateFrom"), 0, "")		//ZapiszZAP(obl, 0, 0, 0, "", 0)

	//Rozrachunek
	//ZapiszTRAROZ(obl, 0, 0)

	//Rejestry VAT ZapiszETRANSFERS(idRO, obl)	
	obl.Clear()
	
	//////////////////////////////[rejestry VAT]//////
	basDK.SetKey("idRO")
	basDK.SetKeySeg("idRO", idRO)
	err = basDK.GetRec(GE)
	while !err && basDK.GetKeySeg("idRO") == idRO //then
			idDK = basDK.GetField("id")
			basDP.SetKey("super")
			basDP.SetKeySeg("super", idDK)
			dataRejestrVATzbiorczy = basDK.GetField("datarej")
			err = basDP.GetRec(GE)
			while !err && basDP.GetKeySeg("super") == idDK
			if !(basDP.GetField("flag") & BFLAGdpDOKOMPL) then	//komplety pomijamy
				iStVAT = basDP.GetField("stvati")

				if (PANUL == basDK.GetField("subtypi")) then
					sRej = using "%d", GetRejestForPozParAnul(basDP.GetField("id"))
				else
					sRej = (using "%d",basDP.GetField("rejestrVati"))
				EndIf
				lSuper = 10500
				iRejVat=-2000
				basXT.SetKey("super")
				basXT.SetKeySeg("super", lSuper)
				basXT.SetKeySeg("kod", "")
				basNT.SetKey("super")
				basNT.SetKeySeg("typi", 18)
				basNT.SetKeySeg("baza", 2)
				err = basXT.GetRec(GE)
				while !err && basXT.GetKeySeg("super") == lSuper					
					strTmp = Using "%l", basXT.GetField("long")							
					if sRej == strTmp then
						basNT.SetKeySeg("super", basXT.GetField("id"))
						if !basNT.GetRec(EQ) then
							buf = basNT.GetField("opis")
							move 0
							find "\$\$"
							iRejVat = val(mid(buf,1,(move 0)-1))
							strRej = mid(buf,1,(move 0)-1)
							if strRej != "" && strRej != "0" && !defrej.MoveTo(strRej) then
								IntegrRO = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
								If IntegrRO Then Exit
							else
								IntegrRO = CzyintegrBlednyRej(strRej, basDK.GetField("kod"), idDK)
								If IntegrRO Then Exit
							endif
						else
							IntegrRO = CzyintegrBlednyRej("", basDK.GetField("kod"), idDK)
							If IntegrRO Then Exit
						endif
						exit // wyjcie z ptli
					endif
					err = basXT.GetRec(NX)
				wend

				if ((PRK == basDK.GetField("subtypi")) || (PAR == basDK.GetField("subtypi")) || (PANUL == basDK.GetField("subtypi"))) then
					strGTU = ""
				else
					strGTU = using "%d",basDP.GetField("JPK_V7")
				EndIf
				If ((PANUL != basDK.GetField("subtypi")) || (basDK.GetField("datasp")>="2020-10-01")) Then
					if !CzyStNP(iStVAT) then 
						TabRejVat.Wstaw(iRejVat,iStVat, basDP.GetField("wartNetto"), basDP.GetField("wartVat"), 0,basDP.GetField("walNetto"), basDP.GetField("walBrutto"),1, 0, strGTU)
					else
						TabRejVat.Wstaw(iRejVat,iStVat, 0, 0, basDP.GetField("wartNetto"), basDP.GetField("walNetto"), basDP.GetField("walBrutto"),1, 0, strGTU)
					endif
					DodajDoOpisu(basDP.GetField("opis"), "/")
				EndIf
			endif
			err = basDP.GetRec(NX)
		wend
		err = basDK.GetRec(NX)
	wend

	if IntegrRO then exit
	WriteStatusBar("")

	//////////////////////////////[rejestry VAT] - koniec//////
	// zapis informacji o rejestrach
	// rejestry VAT
	int nStawka
	float dStawka
	string opis = ""
    int iKasowa

	for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
		for iPomStVat=1 to iPomStVat>TabRejVat.IloscStawek(iPom)
			dst.RejestrVAT.Insert()
			dst.RejestrVAT.Value("soczek") = dst.RejestrVAT.Value("oczek")
			dst.RejestrVAT.Value("def") = TabRejVat.RejVat(iPom).id
			dst.RejestrVAT.Value("typabc") = 1
			buf = dataRejestrVATzbiorczy
			strOkres = Find Regular "????????" // osiem pierwszych znakw
			dst.RejestrVAT.Value("okres") = strOkres + "01"
			dst.RejestrVAT.Value("datadok") = dst.Value( "DataDok" )
			dst.RejestrVAT.Value("dataws") = dst.Value( "DataOper" )
			dst.RejestrVAT.Value("stawka") = TabRejVat.Wartosc(iPom, iPomStVat, "stawka")
			dst.RejestrVAT.Value("brutto") = Round( (TabRejVat.Wartosc(iPom, iPomStVat, "netto") + TabRejVat.Wartosc(iPom, iPomStVat, "vat")),2 )
			dst.RejestrVAT.Value("netto") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "netto"),2 )
			dst.RejestrVAT.Value("vat") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "vat"),2 )
			//dst.RejestrVAT.Value("JPK_V7") = IIF(basDK.GetField("subtypi") != PAR && basDK.GetField("subtypi") != PRK && basDK.GetField("subtypi") != PANUL, TabRejVat.RejVat(iPom).JPK_V7, "")
			dst.RejestrVAT.Value("UE") = 0
			next iPomStVat
		next iPom

		TabRejVat.IloscRejestrow(-1)
		TabRejVat.ClearRec()

	dst.Validate()
	if (ers.Count) then IntegrRO = ShowError("Raport okresowy "+ basRO.GetField("Code"))
	if IntegrRO == 0 then IntegrRO = !dst.Insert()
	ShowStatus(basRO.GetField("Code"),idRO, IntegrRO)
EndSub

int Sub BeginProcessRO()
	// otwarcie baz 
	if ( basKH.Open() ) then error "Bd otwarcia bazy KH"
	if ( basXT.Open() ) then error "Bd otwarcia bazy XT"
	if ( basTW.Open() ) then error "Bd otwarcia bazy TW"
	if ( basDK.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDK2.Open() ) then error "Bd otwarcia bazy DK"
	if ( basDP.Open() ) then error "Bd otwarcia bazy DP"
	if ( basRO.Open() ) then error "Bd otwarcia bazy RO"	
#ifdef HM
	if ( basMG.Open() ) then error "Bd otwarcia bazy MG"
	//if ( basMZ.Open() ) then error "Bd otwarcia bazy MZ"
	//if ( basPW.Open() ) then error "Bd otwarcia bazy PW"
#endif
	if ( basNT.Open() ) then error "Bd otwarcia bazy NT"

	if ( basRV.Open() ) then error "Bd otwarcia bazy RV"

	TabRejVat.ClearRec()
EndSub

int Sub DoProcessRO(long idRO)
	DoProcessRO = 0

	int iVal, errOznacz
	if basRO.GetRecById(idRO) then error "Brak takiego rekordu w bazie RO"

	if ( iNieIntegrOznak && (basRO.GetField("EksportFK") & 0x01) ) then
		DoProcessRO = 1 // pomijamy
			AddError("Nie mona powtrnie wysa raportu " + basRO.GetField("Code") + ".",idRO)
		Exit // nie wysylamy oznakowanych raportw
	endif

	DoProcessRO = IntegrRO(idRO)
	if DoProcessRO then	Exit //pomijamy

	/////////////////////////////////////////////////
	// oznaczamy wyslany dokument
	if ( iOznaczaj) then
		iVal = basRO.GetField("EksportFK")
		iVal |= 0x01
		basRO.SetField("EksportFK", iVal)
		basRO.Update()

		//oznaczamy paragony wyeksportowane w zbiorczym RO - analogicznie jak w SERP
		basDK.SetKey("idRO") : basDK.SetKeySeg("idRO", idRO)
		errOznacz = basDK.GetRec(GE)
		While !errOznacz && basDK.GetKeySeg("idRO") == idRO
			iVal = basDK.GetField("exp_fki")
			iVal |= 0x01
			basDK.SetField( "exp_fki", iVal )
			basDK.Update()
			errOznacz = basDK.GetRec(NX)
		Wend
	endif
EndSub

int Sub EndProcessRO()
	int index = 1
	int err
	int iVal

	basKH.close()
	basXT.close()
	basTW.close()
	basDK.close()
	basDK2.close()
	basDP.close()
	basRO.close()
	basNT.close()
	basRV.close()
	#ifdef HM
		basMG.close()
	#endif
EndSub